/** 
 * @student.info 
 *<BR> Name:          First Last
 *<BR> Date:          0-00-0000
 *<BR> Period:        0
 *<BR> Assignment:    Lesson00
 *<BR> Description:   In a sentence, describe goals
 *<BR> Cite Sources:  People who helped, and/or websites used
 *<BR> Sort Code by:  Jason Quesenberry, Nancy Quesenberry, Mr. Eliot
 */

import java.util.ArrayList;

public class Sorts
{
	private long steps;		//long integer up to 9,223,372,036,854,775,807

	public Sorts()
	{
		steps = 0;
	}

	public void bubbleSort(ArrayList <Integer> List)
	{
		int outer;
		int inner;
		Integer Temp;
		
		for (outer = 0; outer < List.size() - 1; outer++)
		{
			for (inner = 0; inner < List.size() - outer - 1; inner++)
			{
				if (List.get(inner).compareTo(List.get(inner + 1)) > 0)
				{
					//swap
					Temp = List.get(inner);
					List.set(inner, List.get(inner + 1));
					List.set(inner + 1, Temp);
				}
			}
		}
	}

	public void selectionSort(ArrayList <Integer> List)
	{
		int outer;
		int inner;
		int min;
		Integer Temp;

		for (outer = 0; outer < List.size() - 1; outer++)
		{
			min = outer;
			for (inner = outer + 1; inner < List.size(); inner++)
			{
				if (List.get(inner).compareTo(List.get(min)) < 0) 
				{
					min = inner; // a new smallest item is found
				}
			}
			Temp = List.get(outer);
			List.set(outer, List.get(min));
			List.set(min, Temp);
		}
	}

	public void insertionSort(ArrayList <Integer> List)
	{
		int outer;
		int inner;
		int position;
		Integer key;
		
		for (outer = 1; outer < List.size(); outer++)
		{
			position = outer;
			key = List.get(position);

			while (position > 0 && List.get(position - 1).compareTo(key) > 0)
			{
				List.set(position, List.get(position - 1));
				position--;
			}
			List.set(position, key);
		}
	}

	private void merge(ArrayList <Integer> List, int first, int mid, int last)
	{
		int PositionA = first;
		int PositionB = mid + 1;
		int PositionTemp = first;
		int total = last - first + 1;
		int loop;
		boolean doneA = false;
		boolean doneB = false;
		
		//Use Copy Constructor to make "Temp" a **COPY** of "List"
		ArrayList<Integer> Temp = new ArrayList<Integer>(List);

		//merge two sub-arrays together into Temp array
		for (loop = 1; loop <= total; loop++)
		{
			if (doneA)
			{
				Temp.set(PositionTemp, List.get(PositionB));
				PositionB++;
			}
			else if (doneB)
			{
				Temp.set(PositionTemp, List.get(PositionA));
				PositionA++;
			}
			else if (List.get(PositionA).compareTo(List.get(PositionB)) < 0)
			{
				Temp.set(PositionTemp, List.get(PositionA));
				PositionA++;
			}
			else	//List[PositionA] >= List[PositionB]
			{
				Temp.set(PositionTemp, List.get(PositionB));
				PositionB++;
			}

			PositionTemp++;

			if (PositionA > mid)
			{
				doneA = true;
			}
			if (PositionB > last)
			{
				doneB = true;
			}
		}

		// copy Temporary array into original array
		for (loop = first; loop <= last; loop++)
		{
			List.set(loop, Temp.get(loop));
		}
	}

	public void mergeSort(ArrayList <Integer> List, int first, int last)
	{
		int mid;
		int Temp;

		if (first == last)
		{
			// 1 value, do nothing
		}
		else
		{
			if (first + 1 == last)
			{
				// 2 values, swap if necessary
				if (List.get(first).compareTo(List.get(last)) > 0)
				{
					swap(List, first, last);	//**SWAP METHOD**
				}
			}
			else
			{
				// more than 2 values, split List again
				mid = (first + last) / 2;
				mergeSort(List, first, mid);
				mergeSort(List, mid + 1, last);
				merge(List, first, mid, last);
			}
		}
	}
	
	public void quickSort (ArrayList <Integer> List, int first, int last)
	{
		int g = first, h = last;
		int midIndex = (first + last) / 2;
		Integer dividingValue = List.get(midIndex);
		
		do
		{
			while (List.get(g).compareTo(dividingValue) < 0) 
			{
				g++;
			}
			
			while (List.get(h).compareTo(dividingValue) > 0)
			{
				h--;
			}

			if (g <= h)
			{
				//swap(List[g], List[h]);
				swap(List, g, h);		//**SWAP METHOD**
				g++;
				h--;
			}
		}
		while (g < h);
		
		if (h > first)
		{
			quickSort (List, first, h);
		}
		
		if (g < last)
		{		
			quickSort (List, g, last);
		}
	}

	public long getStepCount()
	{
		return steps;
	}

	public void setStepCount(long stepCount)
	{
		steps = stepCount;
	}

	private void swap(ArrayList <Integer> List, int a, int b)
	{
		Integer Temp;
		
		Temp = List.get(a);
		List.set(a, List.get(b));
		List.set(b, Temp);
	}
}